#include <stdlib.mqh>
//+----------------------------------------------------------------------------+
//|                                                                            |
//|      put together by Maumax AKA Foreverold                                 |                                                          
//|      converted from Mt3 using software from http://yousky.free.fr          |
//|      from 3autotargets program by OlegVS                                   |
//|      code also used from  fukinagashi Fibgenerator program                 |
//|      Horizontal Lines are targets/fibonacci support-resistance             |
//|      areas, arrows are Zigzag turning areas, White dotted Vertical Created by the nonlag zigzag        |
//|      Lines are time lines that should be considered as entry/exit areas    |
//+---------------------------------------------------------------------------+

#property copyright "Maumax AKA Foreverold "
#property link      " "

#property indicator_chart_window

#property indicator_buffers 4
#property indicator_color1  Blue
#property indicator_color2  Red
#property indicator_color3  Red
#property indicator_color4  Blue
#property indicator_width1 1
#property indicator_width2 1

extern double BarsCount = 200;
extern double depth = 18;
extern double deviation = 12;
extern double backstep = 3;

extern int ExtDepth=18;
extern int ExtDeviation=12;
extern int ExtBackstep=3;

int LastTradeTime;
double ExtHistoBuffer[];
double ExtHistoBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];


double posA,posB,posC,posD,posX;
double topA,botA,topB,botB,topC,botC,topD,botD,topX,botX;
double XA,AB,BC,CD;
double XAAB,ABBC,BCCD;
datetime TimeX,TimeA,TimeB,TimeC,TimeD,TS1,TS2,TS3,TT1,TT2,TT3;
double PS1,PT1,PS2,PT2,PS3,PT3;
double Target1;
double Target2 ;
double Target3 ;
double Fantasy ;
double CrazyDream;
double Start;
double Stop;


int init()
  { 
   IndicatorBuffers(2);
//---- drawing settings
 

   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0, 233);
  
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1, 234);

   
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer3);
   SetIndexBuffer(1,ExtMapBuffer4);
 
    SetIndexEmptyValue(0,0.0);
  
   
//---- indicator short name
  
  //IndicatorShortName("ZigZag("+ExtDepth+","+ExtDeviation+","+ExtBackstep+")");
//---- initialization done
   return(0);
  }
/*IndicatorBuffers(2);
//---- drawing settings
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0, 233);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1, 234);
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(0,0.0);
//---- indicator short name
*/
int deinit() {
	ObjectDelete("Fibo1");
	ObjectDelete("Fibo2");
	ObjectDelete("Fibo3");
	ObjectDelete("Stop");
	ObjectDelete("Start");
	ObjectDelete("Target1");
	ObjectDelete("Target2");
	ObjectDelete("Target3");
	ObjectDelete("Fantasy");
	ObjectDelete("CrazyDream");
}

void SetLoopCount(int loops)
{
}

void SetIndexValue(int shift, double value)
{
  ExtHistoBuffer[shift] = value;
}

void SetIndexValue2(int shift, double value)
{
  ExtHistoBuffer2[shift] = value;
}




bool MoveObject(string name, int type, datetime Atime, double Aprice, datetime Atime2 = 0, double Aprice2 = 0, color Acolor = CLR_NONE, int Aweight = 0, int Astyle = 0)
{
    if (ObjectFind(name) != -1)
    {
      return(ObjectMove(name, type, Atime, Aprice));
    }
    else
    {
      return(ObjectCreate(name, type, 0, Atime, Aprice, Atime2, Aprice2, 0, 0));
    }
    
    }



//+------------------------------------------------------------------+
//| End                                                              |
//+------------------------------------------------------------------+


int start()
{

int shift = 0;
double Bars_ = 200;
double FractalUp = 0;
double FractalDown = 0;

double PointA = 0;
double PointB = 0;
double PointC = 0;
double zz = 0;
double zzs = 0;
//int j = 0;
bool ft = true;
double m = 0;
double n = 0;
double k = 0;



  
{   double Points = MarketInfo (Symbol(), MODE_POINT);
      int    Shift1, back,lasthighpos,lastlowpos;
      double val,res;
      double curlow,curhigh,lasthigh,lastlow;

      for(Shift1=Bars-ExtDepth; Shift1>=0; Shift1--)
         {
            val=Low[Lowest(NULL,0,MODE_LOW,ExtDepth,Shift1)];
            if(val==lastlow) val=0.0;
            else 
            { 
            lastlow=val; 
            if((Low[Shift1]-val)>(ExtDeviation*Point)) val=0.0;
            else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=ExtMapBuffer3[Shift1+back];
               if((res!=0)&&(res>val)) ExtMapBuffer3[Shift1+back]=0.0; 
              }
           }
        } 
      ExtMapBuffer3[Shift1]=val;
      //--- high
      val=High[Highest(NULL,0,MODE_HIGH,ExtDepth,Shift1)];
      if(val==lasthigh) val=0.0;
      else 
        {
         lasthigh=val;
         if((val-High[Shift1])>(ExtDeviation*Point)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=ExtMapBuffer4[Shift1+back];
               if((res!=0)&&(res<val)) ExtMapBuffer4[Shift1+back]=0.0; 
              } 
           }
        }
      ExtMapBuffer4[Shift1]=val;
     }

   // final cutting 
   lasthigh=-1; lasthighpos=-1;
   lastlow=-1;  lastlowpos=-1;

   for(Shift1=Bars-ExtDepth; Shift1>=0; Shift1--)
     {
      curlow=ExtMapBuffer3[Shift1];
      curhigh=ExtMapBuffer4[Shift1];
      if((curlow==0)&&(curhigh==0)) continue;
      //---
      if(curhigh!=0)
        {
         if(lasthigh>0) 
           {
            if(lasthigh<curhigh) ExtMapBuffer4[lasthighpos]=0;
            else ExtMapBuffer4[Shift1]=0;
           }
         //---
         if(lasthigh<curhigh || lasthigh<0)
           {
            lasthigh=curhigh;
            lasthighpos=Shift1;
           }
         lastlow=-1;
        }
      //----
      if(curlow!=0)
        {
         if(lastlow>0)
           {
            if(lastlow>curlow) ExtMapBuffer3[lastlowpos]=0;
            else ExtMapBuffer3[Shift1]=0;
           }
         //---
         if((curlow<lastlow)||(lastlow<0))
           {
            lastlow=curlow;
            lastlowpos=Shift1;
           } 
         lasthigh=-1;
        }
     }
  
   for(Shift1=Bars-1; Shift1>=0; Shift1--)
     {
      if(Shift1>=Bars-ExtDepth) ExtMapBuffer3[Shift1]=0.0;
      else
        {
         res=ExtMapBuffer4[Shift1];
         if(res!=0.0) ExtMapBuffer3[Shift1]=res;
        }

     }
     
  	int i=0;
  	int LastZigZag, PreviousZigZag,PreviousZigZag2,PreviousZigZag3,PreviousZigZag4;
   
   int h=0;
   while ( ExtMapBuffer3[h]==0 && ExtMapBuffer4[h]==0) 
         {h++;}
   LastZigZag=h;
   h++;
   while(ExtMapBuffer3[h]==0 && ExtMapBuffer4[h]==0) 
         {h++;}
   PreviousZigZag=h;
   h++;
   while(ExtMapBuffer3[h]==0 && ExtMapBuffer4[h]==0) 
      {h++;}
   PreviousZigZag2=h;
   h++;
   while(ExtMapBuffer3[h]==0 && ExtMapBuffer4[h]==0) 
      {h++;}
   PreviousZigZag3=h;
   h++;
   while(ExtMapBuffer3[h]==0 && ExtMapBuffer4[h]==0) 
      {h++;}
   PreviousZigZag4=h;
   
 
   topD=High[LastZigZag];
   botD=Low[LastZigZag];
   topC=High[PreviousZigZag];
   botC=Low[PreviousZigZag];
   topB=High[PreviousZigZag2];
   botB=Low[PreviousZigZag2];
   topA=High[PreviousZigZag3];
   botA=Low[PreviousZigZag3];
   topX=High[PreviousZigZag4];
   botX=Low[PreviousZigZag4];
   TimeD=Time[LastZigZag];
   TimeC=Time[PreviousZigZag];
   TimeB=Time[PreviousZigZag2];
   TimeA=Time[PreviousZigZag3];
   TimeX=Time[PreviousZigZag4];
   
 if(topD>topC)// D IS A PEAK
      {//defining fib1 as CD retracement
         TS1=TimeC;
         PS1=botC;
         TT1=TimeD;
         PT1=topD;
         if (topB>topD)
         {//defining fib2 as BC retracement
            TS2=TimeB;
            PS2=topB;
            TT2=TimeC;
            PT2=botC;
         }
         if (topB<=topD)
         {//defining fib2 as BC extension
            TS2=TimeC;
            PS2=botC;
            TT2=TimeB;
            PT2=topB;
         }
         if (botA<=botC)
         {//defining fib3 as AB retracement
            TS3=TimeA;
            PS3=botA;
            TT3=TimeB;
            PT3=topB;
         }
      }
      
      if(botD<botC)// D IS A TROUGH
      {//defining fib1 as CD retracement
         TS1=TimeC;
         PS1=topC;
         TT1=TimeD;
         PT1=botD;
         if (botB<=botD)
         {//defining fib2 as BC retracement
            TS2=TimeB;
            PS2=botB;
            TT2=TimeC;
            PT2=topC;
         }
         if (botB>botD)
         {//defining fib2 as BC extension
            TS2=TimeC;
            PS2=topC;
            TT2=TimeB;
            PT2=botB;
         }
         //defining fib3 as AB retracement
            TS3=TimeA;
            PS3=topA;
            TT3=TimeB;
            PT3=botB;
         
      }    
  if(botD<botC)// D IS A TROUGH
      {//defining fib1 as CD retracement
         TS1=TimeC;
         PS1=topC;
         TT1=TimeD;
         PT1=botD;
         if (botB<=botD)
         {//defining fib2 as BC retracement
            TS2=TimeB;
            PS2=botB;
            TT2=TimeC;
            PT2=topC;
         }
         if (botB>botD)
         {//defining fib2 as BC extension
            TS2=TimeC;
            PS2=topC;
            TT2=TimeB;
            PT2=botB;
         }
         //defining fib3 as AB retracement
            TS3=TimeA;
            PS3=topA;
            TT3=TimeB;
            PT3=botB;
         
      }    
      
   
  


SetLoopCount(0);
if( BarsCount < 1 ) Bars_ = Bars
; else Bars_ = BarsCount;

for(shift =Bars_-1;shift >=0 ;shift --){ 
zzs=iCustom(NULL, 0, "ZigZag",depth,deviation,backstep,0,1);
if( zzs != 0 || ft ) { PointC=0;PointB=0;PointA=0;k=0;n=0;m=0; 
for(i=0;i<=BarsCount ;i++){ 
zz=iCustom(NULL, 0, "ZigZag",depth,deviation,backstep,0,i);
if( zz != 0 && k == 0 ) { k=1;PointC=zz;} 
if( zz != 0 && zz != PointC && k == 1 && n == 0 ) { n=1;PointB=zz;} 
if( zz != 0 && zz != PointC && zz != PointB && k == 1 && n == 1 && m == 0 ) { m=1;PointA=zz;} 
if( zz == 0 && PointC != 0 && PointB != 0 && PointA != 0 && PointC != PointB && PointB != PointA && PointA != PointC ) break;
} ft=false;} 

Target1=NormalizeDouble((PointB-PointA)*0.618+PointC,4);
Target2=PointB-PointA+PointC;
Target3=NormalizeDouble((PointB-PointA)*1.618+PointC,4);
Fantasy=NormalizeDouble((PointB-PointA)*2.618+PointC,4);
CrazyDream=NormalizeDouble((PointB-PointA)*4.618+PointC,4);
if( PointB<PointC ) 
{
Start= NormalizeDouble((PointB-PointA)*0.318+PointC,4)-(Ask-Bid);
Stop=PointC+2*(Ask-Bid);
}
if( PointB>PointC ) 
{
Start= NormalizeDouble((PointB-PointA)*0.318+PointC,4)+(Ask-Bid);
Stop=PointC-2*(Ask-Bid);
}
MoveObject("Target1",OBJ_HLINE,Time[1],Target1,Time[1]);

MoveObject("Target2",OBJ_HLINE,Time[1],Target2,Time[1]);

MoveObject("Target3",OBJ_HLINE,Time[1],Target3,Time[1]);

MoveObject("Fantasy",OBJ_HLINE,Time[1],Fantasy,Time[1]);

MoveObject("CrazyDream",OBJ_HLINE,Time[1],CrazyDream,Time[1]);

MoveObject("Start",OBJ_HLINE,Time[1],Start,Time[1]);

MoveObject("Stop",OBJ_HLINE,Time[1],Stop,Time[1]);


	SetIndexValue(shift,zzs);
	SetIndexValue2(shift,Start);
} 
 
  return(0);
}

}